SystemOrganization addCategory: #GODSocialNetIO!

GODData subclass: #SNETFacebookEventsData
	instanceVariableNames: 'events'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'GODSocialNetIO'!

!SNETFacebookEventsData class methodsFor: 'instance creation' stamp: 'EBA 11/3/2014 20:48'!
new: json
	| newInstance |
	newInstance := self new.
	
	((Json readFrom: json readStream) at: 'data') collect: [:event |
		newInstance addEvent: event].
	
	^ newInstance! !

!SNETFacebookEventsData methodsFor: 'private' stamp: 'EBA 10/26/2014 03:31'!
addEvent: json
	"Add new event to list"
	
	events add: (SNETFacebookEvent new: json)! !

!SNETFacebookEventsData methodsFor: 'accessing' stamp: 'EBA 10/26/2014 03:32'!
getEvent: position
	"Get event at parameter position"
	
	^ events at: position! !

!SNETFacebookEventsData methodsFor: 'initialize-release' stamp: 'EBA 10/26/2014 03:31'!
initialize
	"Initialize events data"
	super initialize.

	events := OrderedCollection new.! !

!SNETFacebookEventsData methodsFor: 'accessing' stamp: 'EBA 10/26/2014 03:32'!
size
	"Get size of container"
	
	^ events size! !

GODData subclass: #SNETFacebookGroupDescriptionData
	instanceVariableNames: 'id name description'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'GODSocialNetIO'!

!SNETFacebookGroupDescriptionData class methodsFor: 'instance creation' stamp: 'EBA 11/3/2014 20:49'!
new: content
	| newInstance json |
	newInstance := self new.
	
	json := Json readFrom: content readStream.
	
	newInstance setId: (json at: 'id' ifPresent: [:value | value]).
	newInstance setName: (json at: 'name' ifPresent: [:value | value]).
	newInstance setDescription: (json at: 'description' ifPresent: [:value | value]).
	
	^ newInstance! !

!SNETFacebookGroupDescriptionData methodsFor: 'accessing' stamp: 'EBA 10/26/2014 03:13'!
getDescription
	"Get description of group"

	^ description! !

!SNETFacebookGroupDescriptionData methodsFor: 'accessing' stamp: 'EBA 10/26/2014 03:13'!
getId
	"Get id of group"

	^ id! !

!SNETFacebookGroupDescriptionData methodsFor: 'accessing' stamp: 'EBA 10/26/2014 03:13'!
getName
	"Get name of group"

	^ name! !

!SNETFacebookGroupDescriptionData methodsFor: 'private' stamp: 'EBA 10/26/2014 03:13'!
setDescription: text
	"Set description of group"
	
	description := text! !

!SNETFacebookGroupDescriptionData methodsFor: 'private' stamp: 'EBA 10/26/2014 03:13'!
setId: idNumber
	"Set id of group"
	
	id := idNumber! !

!SNETFacebookGroupDescriptionData methodsFor: 'private' stamp: 'EBA 10/26/2014 03:13'!
setName: pageName
	"Set name of group"
	
	name := pageName! !

GODData subclass: #SNETFacebookGroupsData
	instanceVariableNames: 'groups'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'GODSocialNetIO'!

!SNETFacebookGroupsData class methodsFor: 'instance creation' stamp: 'EBA 11/3/2014 20:49'!
new: json
	| newInstance |
	newInstance := self new.
	
	((Json readFrom: json readStream) at: 'data') collect: [:group |
		newInstance addGroup: group].
	
	^ newInstance! !

!SNETFacebookGroupsData methodsFor: 'private' stamp: 'EBA 10/26/2014 03:05'!
addGroup: json
	"Add new group to list"
	
	groups add: (SNETFacebookGroup new: json)! !

!SNETFacebookGroupsData methodsFor: 'accessing' stamp: 'EBA 10/26/2014 03:05'!
getGroup: position
	"Get group at parameter position"
	
	^ groups at: position! !

!SNETFacebookGroupsData methodsFor: 'initialize-release' stamp: 'EBA 10/26/2014 03:06'!
initialize
	"Initialize groups data"
	super initialize.

	groups := OrderedCollection new.! !

!SNETFacebookGroupsData methodsFor: 'accessing' stamp: 'EBA 10/26/2014 03:06'!
size
	"Get size of container"
	
	^ groups size! !

GODData subclass: #SNETFacebookPageDescriptionData
	instanceVariableNames: 'id name category description likes'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'GODSocialNetIO'!

!SNETFacebookPageDescriptionData class methodsFor: 'instance creation' stamp: 'EBA 11/3/2014 20:50'!
new: content
	| newInstance json |
	newInstance := self new.
	
	json := Json readFrom: content readStream.
	
	newInstance setId: (json at: 'id' ifPresent: [:value | value]).
	newInstance setName: (json at: 'name' ifPresent: [:value | value]).
	newInstance setCategory: (json at: 'category' ifPresent: [:value | value]).
	newInstance setDescription: (json at: 'description' ifPresent: [:value | value]).
	newInstance setLikes: (json at: 'likes' ifPresent: [:value | value]).
	
	^ newInstance! !

!SNETFacebookPageDescriptionData methodsFor: 'accessing' stamp: 'EBA 10/26/2014 02:53'!
getCategory
	"Get category of page"

	^ category! !

!SNETFacebookPageDescriptionData methodsFor: 'accessing' stamp: 'EBA 10/26/2014 02:53'!
getDescription
	"Get description of page"

	^ description! !

!SNETFacebookPageDescriptionData methodsFor: 'accessing' stamp: 'EBA 10/26/2014 02:53'!
getId
	"Get id of page"

	^ id! !

!SNETFacebookPageDescriptionData methodsFor: 'accessing' stamp: 'EBA 10/26/2014 02:53'!
getLikes
	"Get number of likes of page"

	^ likes! !

!SNETFacebookPageDescriptionData methodsFor: 'accessing' stamp: 'EBA 10/26/2014 02:53'!
getName
	"Get name of page"

	^ name! !

!SNETFacebookPageDescriptionData methodsFor: 'private' stamp: 'EBA 10/26/2014 02:52'!
setCategory: pageCategory
	"Set category of page"
	
	category := pageCategory! !

!SNETFacebookPageDescriptionData methodsFor: 'private' stamp: 'EBA 10/26/2014 02:52'!
setDescription: text
	"Set description of page"
	
	description := text! !

!SNETFacebookPageDescriptionData methodsFor: 'private' stamp: 'EBA 10/26/2014 02:53'!
setId: idNumber
	"Set id of page"
	
	id := idNumber! !

!SNETFacebookPageDescriptionData methodsFor: 'private' stamp: 'EBA 10/26/2014 02:53'!
setLikes: number
	"Set number of likes of page"
	
	likes := number! !

!SNETFacebookPageDescriptionData methodsFor: 'private' stamp: 'EBA 10/26/2014 02:53'!
setName: pageName
	"Set name of page"
	
	name := pageName! !

GODData subclass: #SNETFacebookPagesData
	instanceVariableNames: 'pages'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'GODSocialNetIO'!

!SNETFacebookPagesData class methodsFor: 'instance creation' stamp: 'EBA 11/3/2014 20:50'!
new: json
	| newInstance |
	newInstance := self new.
	
	((Json readFrom: json readStream) at: 'data') collect: [:page |
		newInstance addPage: page].
	
	^ newInstance! !

!SNETFacebookPagesData methodsFor: 'private' stamp: 'EBA 10/26/2014 02:34'!
addPage: json
	"Add new page to list"
	
	pages add: (SNETFacebookPage new: json)! !

!SNETFacebookPagesData methodsFor: 'accessing' stamp: 'EBA 10/26/2014 02:34'!
getPage: position
	"Get page at parameter position"
	
	^ pages at: position! !

!SNETFacebookPagesData methodsFor: 'initialize-release' stamp: 'EBA 10/26/2014 03:06'!
initialize
	"Initialize pages data"
	super initialize.

	pages := OrderedCollection new.! !

!SNETFacebookPagesData methodsFor: 'accessing' stamp: 'EBA 10/26/2014 02:42'!
size
	"Get size of container"
	
	^ pages size! !

GODData subclass: #SNETFacebookPostsData
	instanceVariableNames: 'posts'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'GODSocialNetIO'!

!SNETFacebookPostsData class methodsFor: 'instance creation' stamp: 'EBA 11/3/2014 20:50'!
new: json
	| newInstance |
	newInstance := self new.
	
	((Json readFrom: json readStream) at: 'data') collect: [:post |
		newInstance addPost: post].
	
	^ newInstance! !

!SNETFacebookPostsData methodsFor: 'private' stamp: 'EBA 10/26/2014 00:46'!
addPost: json
	"Add new post to list"
	
	posts add: (SNETFacebookPost new: json)! !

!SNETFacebookPostsData methodsFor: 'accessing' stamp: 'EBA 10/26/2014 02:12'!
getPost: position
	"Get post at parameter position"
	
	^ posts at: position! !

!SNETFacebookPostsData methodsFor: 'initialize-release' stamp: 'EBA 10/26/2014 00:35'!
initialize
	"Initialize posts data"
	super initialize.

	posts := OrderedCollection new.! !

!SNETFacebookPostsData methodsFor: 'accessing' stamp: 'EBA 10/26/2014 02:41'!
size
	"Get size of container"
	
	^ posts size! !

GODData subclass: #SNETFacebookUsersData
	instanceVariableNames: 'users'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'GODSocialNetIO'!

!SNETFacebookUsersData class methodsFor: 'instance creation' stamp: 'EBA 10/26/2014 03:19'!
new: json
	| newInstance |
	newInstance := self new.
	
	^ newInstance! !

!SNETFacebookUsersData methodsFor: 'accessing' stamp: 'EBA 10/26/2014 03:18'!
getUser: position
	"Get user at parameter position"
	
	^ users at: position! !

!SNETFacebookUsersData methodsFor: 'initialize-release' stamp: 'EBA 10/26/2014 03:18'!
initialize
	"Initialize users data"
	super initialize.

	users := OrderedCollection new.! !

!SNETFacebookUsersData methodsFor: 'accessing' stamp: 'EBA 10/26/2014 03:18'!
size
	"Get size of container"
	
	^ users size! !

GODData subclass: #SNETTwitterTweetsData
	instanceVariableNames: 'tweets'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'GODSocialNetIO'!

!SNETTwitterTweetsData class methodsFor: 'instance creation' stamp: 'EBA 11/3/2014 20:34'!
new: json
	| newInstance |
	newInstance := self new.
	
	(Json readFrom: json readStream) collect: [:tweet |
		newInstance addTweet: tweet].
	
	^ newInstance! !

!SNETTwitterTweetsData class methodsFor: 'instance creation' stamp: 'EBA 11/3/2014 20:34'!
new: json type: type
	| newInstance |
	newInstance := self new.
	
	((Json readFrom: json readStream) at: 'statuses') collect: [:tweet |
		newInstance addTweet: tweet].
	
	^ newInstance! !

!SNETTwitterTweetsData methodsFor: 'private' stamp: 'EBA 10/26/2014 03:47'!
addTweet: json
	"Add new tweet to list"
	
	tweets add: (SNETTwitterTweet new: json)! !

!SNETTwitterTweetsData methodsFor: 'accessing' stamp: 'EBA 10/26/2014 03:46'!
getPost: position
	"Get post at parameter position"
	
	^ posts at: position! !

!SNETTwitterTweetsData methodsFor: 'accessing' stamp: 'EBA 10/26/2014 03:47'!
getTweet: position
	"Get tweet at parameter position"
	
	^ tweets at: position! !

!SNETTwitterTweetsData methodsFor: 'initialize-release' stamp: 'EBA 10/26/2014 03:47'!
initialize
	"Initialize tweets data"
	super initialize.

	tweets := OrderedCollection new.! !

!SNETTwitterTweetsData methodsFor: 'accessing' stamp: 'EBA 10/26/2014 03:47'!
size
	"Get size of container"
	
	^ tweets size! !

ServiceProvider subclass: #GODSocialNetIOServiceProvider
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'GODSocialNetIO'!

!GODSocialNetIOServiceProvider class methodsFor: 'initialization' stamp: 'AB 10/31/2014 17:45'!
initialize 
	ServiceRegistry buildProvider: self new! !

Object subclass: #SNETFacebookComment
	instanceVariableNames: 'id message likes'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'GODSocialNetIO'!

!SNETFacebookComment class methodsFor: 'instance creation' stamp: 'EBA 10/26/2014 02:06'!
new: json
	| newInstance |
	newInstance := self new.
	
	newInstance setId: (json at: 'id' ifPresent: [:value | value]).
	newInstance setLikes: (json at: 'like_count' ifPresent: [:value | value asInteger]).
	newInstance setMessage: (json at: 'message' ifPresent: [:value | value]).
	
	^ newInstance! !

!SNETFacebookComment methodsFor: 'accessing' stamp: 'EBA 10/26/2014 01:42'!
getId
	"Get user id from comment"

	^ id! !

!SNETFacebookComment methodsFor: 'accessing' stamp: 'EBA 10/26/2014 01:42'!
getLikes
	"Get number of likes from comment"

	^ likes! !

!SNETFacebookComment methodsFor: 'accessing' stamp: 'EBA 10/26/2014 01:42'!
getMessage
	"Get message from comment"

	^ message! !

!SNETFacebookComment methodsFor: 'private' stamp: 'EBA 10/26/2014 01:44'!
setId: idNumber
	"Set id from comment"
	
	id := idNumber! !

!SNETFacebookComment methodsFor: 'private' stamp: 'EBA 10/26/2014 01:43'!
setLikes: number
	"Set number of likes from post"
	
	likes := number! !

!SNETFacebookComment methodsFor: 'private' stamp: 'EBA 10/26/2014 01:43'!
setMessage: text
	"Set message from post"
	
	message := text! !

Object subclass: #SNETFacebookEvent
	instanceVariableNames: 'id name location'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'GODSocialNetIO'!

!SNETFacebookEvent class methodsFor: 'instance creation' stamp: 'EBA 10/26/2014 03:30'!
new: json
	| newInstance |
	newInstance := self new.
	
	newInstance setId: (json at: 'id' ifPresent: [:value | value]).
	newInstance setName: (json at: 'name' ifPresent: [:value | value]).
	newInstance setLocation: (json at: 'location' ifPresent: [:value | value]).
	
	^ newInstance! !

!SNETFacebookEvent methodsFor: 'accessing' stamp: 'EBA 10/26/2014 03:27'!
getId
	"Get id from event"

	^ id! !

!SNETFacebookEvent methodsFor: 'accessing' stamp: 'EBA 10/26/2014 03:28'!
getLocation
	"Get location from event"

	^ location! !

!SNETFacebookEvent methodsFor: 'accessing' stamp: 'EBA 10/26/2014 03:28'!
getName
	"Get name from event"

	^ name! !

!SNETFacebookEvent methodsFor: 'private' stamp: 'EBA 10/26/2014 03:28'!
setId: idNumber
	"Set id from event"
	
	id := idNumber! !

!SNETFacebookEvent methodsFor: 'private' stamp: 'EBA 10/26/2014 03:29'!
setLocation: eventLocation
	"Set location from event"
	
	location := eventLocation! !

!SNETFacebookEvent methodsFor: 'private' stamp: 'EBA 10/26/2014 03:29'!
setName: eventName
	"Set name from event"
	
	name := eventName! !

Object subclass: #SNETFacebookGroup
	instanceVariableNames: 'name id'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'GODSocialNetIO'!

!SNETFacebookGroup class methodsFor: 'instance creation' stamp: 'EBA 10/26/2014 03:08'!
new: json
	| newInstance |
	newInstance := self new.
	
	newInstance setId: (json at: 'id' ifPresent: [:value | value]).
	newInstance setName: (json at: 'name' ifPresent: [:value | value]).
	
	^ newInstance! !

!SNETFacebookGroup methodsFor: 'accessing' stamp: 'EBA 10/26/2014 03:07'!
getId
	"Get id from group"

	^ id! !

!SNETFacebookGroup methodsFor: 'accessing' stamp: 'EBA 10/26/2014 03:07'!
getName
	"Get name from group"

	^ name! !

!SNETFacebookGroup methodsFor: 'private' stamp: 'EBA 10/26/2014 03:07'!
setId: idNumber
	"Set id from group"
	
	id := idNumber! !

!SNETFacebookGroup methodsFor: 'private' stamp: 'EBA 10/26/2014 03:07'!
setName: pageName
	"Set name from group"
	
	name := pageName! !

Object subclass: #SNETFacebookPage
	instanceVariableNames: 'category name id'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'GODSocialNetIO'!

!SNETFacebookPage class methodsFor: 'instance creation' stamp: 'EBA 10/26/2014 02:40'!
new: json
	| newInstance |
	newInstance := self new.
	
	newInstance setId: (json at: 'id' ifPresent: [:value | value]).
	newInstance setName: (json at: 'name' ifPresent: [:value | value]).
	newInstance setCategory: (json at: 'category' ifPresent: [:value | value]).
	
	^ newInstance! !

!SNETFacebookPage methodsFor: 'accessing' stamp: 'EBA 10/26/2014 02:37'!
getCategory
	"Get category from page"

	^ category! !

!SNETFacebookPage methodsFor: 'accessing' stamp: 'EBA 10/26/2014 02:36'!
getId
	"Get id from page"

	^ id! !

!SNETFacebookPage methodsFor: 'accessing' stamp: 'EBA 10/26/2014 02:37'!
getName
	"Get name from page"

	^ name! !

!SNETFacebookPage methodsFor: 'private' stamp: 'EBA 10/26/2014 02:38'!
setCategory: pageCategory
	"Set category from page"
	
	category := pageCategory! !

!SNETFacebookPage methodsFor: 'private' stamp: 'EBA 10/26/2014 02:37'!
setId: idNumber
	"Set id from page"
	
	id := idNumber! !

!SNETFacebookPage methodsFor: 'private' stamp: 'EBA 10/26/2014 02:38'!
setName: pageName
	"Set name from page"
	
	name := pageName! !

Object subclass: #SNETFacebookPost
	instanceVariableNames: 'message type caption description picture likes shares comments'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'GODSocialNetIO'!

!SNETFacebookPost class methodsFor: 'instance creation' stamp: 'EBA 11/3/2014 21:11'!
new: json
	| newInstance |
	newInstance := self new.
	
	json at: 'likes' ifPresent: [:like | like at: 'data' ifPresent: [:data | newInstance setLikes: data size]].
	json at: 'shares' ifPresent: [:share | share at: 'count' ifPresent: [:count |
			newInstance setShares: count asInteger]].
	
	newInstance setType: (json at: 'type' ifPresent: [:value | value]).
	newInstance setMessage: (json at: 'message' ifPresent: [:value | value]).
	newInstance setPicture: (json at: 'picture' ifPresent: [:value | value]).
	newInstance setCaption: (json at: 'caption' ifPresent: [:value | value]).
	newInstance setDescription: (json at: 'description' ifPresent: [:value | value]).
	
	json at: 'comments' ifPresent: [:comment | (comment at: 'data') collect: [:data |
			newInstance addComment: data]].
	
	^ newInstance! !

!SNETFacebookPost methodsFor: 'private' stamp: 'EBA 10/26/2014 02:08'!
addComment: json
	"Add new comment to list"
	
	comments add: (SNETFacebookComment new: json)! !

!SNETFacebookPost methodsFor: 'accessing' stamp: 'EBA 10/26/2014 01:06'!
getCaption
	"Get caption from post"

	^ caption! !

!SNETFacebookPost methodsFor: 'accessing' stamp: 'EBA 10/26/2014 02:12'!
getComment: position
	"Get comment at parameter position"

	^ comments at: position! !

!SNETFacebookPost methodsFor: 'accessing' stamp: 'EBA 10/26/2014 01:07'!
getDescription
	"Get description from post"

	^ description! !

!SNETFacebookPost methodsFor: 'accessing' stamp: 'EBA 10/26/2014 00:29'!
getLikes
	"Get number of likes from post"

	^ likes! !

!SNETFacebookPost methodsFor: 'accessing' stamp: 'EBA 10/26/2014 00:32'!
getMessage
	"Get message from post"

	^ message! !

!SNETFacebookPost methodsFor: 'accessing' stamp: 'EBA 10/26/2014 01:05'!
getPicture
	"Get picture from post"

	^ picture! !

!SNETFacebookPost methodsFor: 'accessing' stamp: 'EBA 10/26/2014 00:30'!
getShares
	"Get number of shares from post"

	^ shares! !

!SNETFacebookPost methodsFor: 'accessing' stamp: 'EBA 10/26/2014 02:14'!
getType
	"Get type of post"

	^ type! !

!SNETFacebookPost methodsFor: 'initialize-release' stamp: 'EBA 10/26/2014 01:50'!
initialize
	"Initialize posts data"
	super initialize.

	comments := OrderedCollection new.! !

!SNETFacebookPost methodsFor: 'private' stamp: 'EBA 10/26/2014 01:06'!
setCaption: text
	"Set caption from post"
	
	caption := text! !

!SNETFacebookPost methodsFor: 'private' stamp: 'EBA 10/26/2014 01:06'!
setDescription: text
	"Set description from post"
	
	description := text! !

!SNETFacebookPost methodsFor: 'private' stamp: 'EBA 10/26/2014 00:28'!
setLikes: number
	"Set number of likes from post"
	
	likes := number! !

!SNETFacebookPost methodsFor: 'private' stamp: 'EBA 10/26/2014 00:31'!
setMessage: text
	"Set message from post"
	
	message := text! !

!SNETFacebookPost methodsFor: 'private' stamp: 'EBA 10/26/2014 01:05'!
setPicture: url
	"Set picture from post"
	
	picture := url! !

!SNETFacebookPost methodsFor: 'private' stamp: 'EBA 10/26/2014 00:30'!
setShares: number
	"Set number of shares from post"
	
	shares := number! !

!SNETFacebookPost methodsFor: 'private' stamp: 'EBA 10/26/2014 02:13'!
setType: postType
	"Set type of post"
	
	type := postType! !

Object subclass: #SNETFetcher
	instanceVariableNames: 'accessToken'
	classVariableNames: 'ApiUrl'
	poolDictionaries: ''
	category: 'GODSocialNetIO'!

!SNETFetcher commentStamp: 'T.A. 10/5/2014 18:43' prior: 0!
Interface for social network searching.!

SNETFetcher subclass: #SNETFacebookFetcher
	instanceVariableNames: ''
	classVariableNames: 'ClientId ClientSecret UserAgent'
	poolDictionaries: ''
	category: 'GODSocialNetIO'!

!SNETFacebookFetcher commentStamp: 'T.A. 10/5/2014 19:07' prior: 0!
Fetcher implementation for facebook.!

!SNETFacebookFetcher methodsFor: 'connection' stamp: 'EBA 10/25/2014 19:18'!
connect
	"Get accessToken from Facebook"
	
	| grantType url content json |
	grantType := 'client_credentials'.
	
	url := ApiUrl, 'oauth/access_token?client_id=', ClientId, '&client_secret=', ClientSecret,
		'&grant_type=', grantType.
		
	content := self sendRequest: url.
	
	"Get test users from app"
	url := ApiUrl, ClientId, '/accounts/test-users?', content.
	
	content := self sendRequest: url.
	
	"Get accessToken from first user"
	json := WebUtils jsonDecode: content readStream.
	accessToken := 'access_token=', ((json at: 'data') first at: 'access_token')! !

!SNETFacebookFetcher methodsFor: 'accessing' stamp: 'EBA 10/26/2014 03:33'!
events: event
	"Search for events with the parameter name"
	
	| url |
	url := ApiUrl, 'search?q=', (event copyReplaceAll: ' ' with: '+'), '&type=event&', accessToken.
	
	^ SNETFacebookEventsData new: (self sendRequest: url)! !

!SNETFacebookFetcher methodsFor: 'accessing' stamp: 'EBA 10/26/2014 03:33'!
events: event since: since
	"Search for events with the parameter name since some date"
	
	| url |
	url := ApiUrl, 'search?q=', (event copyReplaceAll: ' ' with: '+'), '&since=', since yyyymmdd,
		'&type=event&', accessToken.
	
	^ SNETFacebookEventsData new: (self sendRequest: url)! !

!SNETFacebookFetcher methodsFor: 'accessing' stamp: 'EBA 10/26/2014 03:33'!
events: event since: since until: until
	"Search for events with the parameter name since some date until another date"
	
	| url |
	url := ApiUrl, 'search?q=', (event copyReplaceAll: ' ' with: '+'), '&since=', since yyyymmdd,
		'&until=', until yyyymmdd, '&type=event&', accessToken.
	
	^ SNETFacebookEventsData new: (self sendRequest: url)! !

!SNETFacebookFetcher methodsFor: 'private' stamp: 'EBA 10/25/2014 19:37'!
getById: id
	"Get information from some Id"
	
	| url |
	url := ApiUrl, id, '?', accessToken.
	
	^ self sendRequest: url! !

!SNETFacebookFetcher methodsFor: 'accessing' stamp: 'T.A. 10/31/2014 20:28'!
groupDescription: groupId
	"Get group information by Id"
	
	^ SNETFacebookGroupDescriptionData new: (self getById: groupId).! !

!SNETFacebookFetcher methodsFor: 'accessing' stamp: 'EBA 10/26/2014 03:09'!
groups: group
	"Search for groups with the parameter name"
	
	| url |
	url := ApiUrl, 'search?q=', (group copyReplaceAll: ' ' with: '+'), '&type=group&', accessToken.
	
	^ SNETFacebookGroupsData new: (self sendRequest: url)! !

!SNETFacebookFetcher methodsFor: 'initialize-release' stamp: 'EBA 10/25/2014 18:59'!
initialize
	"initialize Facebook"
	super initialize.
	
	ApiUrl := 'https://graph.facebook.com/v2.1/'.
	UserAgent := 'Mozilla/5.0'.
	ClientId := '743980072335668'.
	ClientSecret := '0d3878c173d1f15ad5d158c0ef545107'! !

!SNETFacebookFetcher methodsFor: 'accessing' stamp: 'EBA 10/26/2014 02:59'!
pageDescription: pageId
	"Get page information by Id"
	
	^ SNETFacebookPageDescriptionData new: (self getById: pageId).! !

!SNETFacebookFetcher methodsFor: 'accessing' stamp: 'EBA 10/26/2014 02:44'!
pages: page
	"Search for pages with the parameter name"
	
	| url |
	url := ApiUrl, 'search?q=', (page copyReplaceAll: ' ' with: '+'), '&type=page&', accessToken.
	
	^ SNETFacebookPagesData new: (self sendRequest: url)! !

!SNETFacebookFetcher methodsFor: 'accessing' stamp: 'EBA 11/3/2014 21:03'!
posts: user
	"Get posts from user"
	
	| url |
	url := ApiUrl, user, '/posts?', accessToken.
	
	^ SNETFacebookPostsData new: (self sendRequest: url)! !

!SNETFacebookFetcher methodsFor: 'accessing' stamp: 'EBA 10/26/2014 02:21'!
posts: user since: since
	"Get posts from user since some date"
	
	| url |
	url := ApiUrl, user, '/posts?since=', since yyyymmdd, '&', accessToken.
	
	^ SNETFacebookPostsData new: (self sendRequest: url)! !

!SNETFacebookFetcher methodsFor: 'accessing' stamp: 'EBA 10/26/2014 02:21'!
posts: user since: since until: until
	"Get posts from user since some date until another date"
	
	| url |
	url := ApiUrl, user, '/posts?since=', since yyyymmdd, '&until=', until yyyymmdd, '&', accessToken.
	
	^ SNETFacebookPostsData new: (self sendRequest: url)! !

!SNETFacebookFetcher methodsFor: 'private' stamp: 'EBA 10/25/2014 18:54'!
sendRequest: url
	"Send a HTTP request"
	
	| response |
	response := [WebClient new httpGet: url do: [:req | req addHeader: 'User-Agent' value: UserAgent.]]
	"Ignore all certificate issues when using HTTPS/SSL"
	on: SqueakSSLCertificateError do: [:ex | ex resume].
	
	^response content! !

!SNETFacebookFetcher methodsFor: 'accessing' stamp: 'EBA 10/26/2014 03:19'!
users: user
	"Search for users with the parameter name"
	
	| url |
	url := ApiUrl, 'search?q=', user encodeForHTTP, '&type=user&', accessToken.
	
	^ SNETFacebookUsersData new: (self sendRequest: url)! !

!SNETFetcher class methodsFor: 'as yet unclassified' stamp: 'EBA 10/25/2014 17:41'!
new
	^ super new! !

!SNETFetcher methodsFor: 'connection' stamp: 'EBA 10/25/2014 18:44'!
connect
	"Get accessToken from Facebook"
	
	^ self subclassResponsibility! !

!SNETFetcher methodsFor: 'initialize-release' stamp: 'EBA 10/25/2014 18:09'!
initialize
	"initialize Facebook"
	
	super initialize! !

!SNETFetcher methodsFor: 'private' stamp: 'EBA 10/25/2014 18:47'!
sendRequest: url
	"Send a HTTP request"

	^ self subclassResponsibility! !

SNETFetcher subclass: #SNETTwitterFetcher
	instanceVariableNames: 'tokenType'
	classVariableNames: 'ClientId ClientSecret UserAgent'
	poolDictionaries: ''
	category: 'GODSocialNetIO'!

!SNETTwitterFetcher commentStamp: 'T.A. 10/5/2014 19:07' prior: 0!
Fetcher implementation for twitter.!

!SNETTwitterFetcher methodsFor: 'connection' stamp: 'EBA 10/25/2014 21:31'!
connect
	"Get accessToken from Twitter"
	
	| grantType url content |
	grantType := 'client_credentials'.
	tokenType := 'Basic'.
	accessToken := (ClientId, ':', ClientSecret) base64Encoded.
	
	url := ApiUrl, 'oauth2/token?&grant_type=', grantType.
	
	content := self sendRequest: url method: 'POST'.
	
	accessToken := (WebUtils jsonDecode: content readStream) at: 'access_token'.
	tokenType := (WebUtils jsonDecode: content readStream) at: 'token_type'.
	
^ accessToken, ' ', tokenType! !

!SNETTwitterFetcher methodsFor: 'initialize-release' stamp: 'EBA 10/25/2014 21:17'!
initialize
	"initialize Twitter"
	super initialize.
	
	ApiUrl := 'https://api.twitter.com/'.
	UserAgent := 'teste_app_poo'.
	ClientId := 'w8SKM5qJVaIgiNN3sVh4fZlha'.
	ClientSecret := 'RljHR2GPp3iPZZQ3kqE4EqowUPBHkWR0wtVv25DD5IFzp6nCGQ'.
	tokenType := 'Basic'! !

!SNETTwitterFetcher methodsFor: 'accessing' stamp: 'EBA 10/25/2014 21:37'!
posts: user
	"Get posts from user"
	
	^ self posts: user maximum: 20! !

!SNETTwitterFetcher methodsFor: 'accessing' stamp: 'EBA 10/26/2014 03:56'!
posts: user maximum: max
	"Get posts from user"
	
	| url |
	url := ApiUrl, '1.1/statuses/user_timeline.json?screen_name=', user encodeForHTTP, '&count=', max.
	
	^ SNETTwitterTweetsData new: (self sendRequest: url)! !

!SNETTwitterFetcher methodsFor: 'private' stamp: 'EBA 10/25/2014 21:31'!
sendRequest: url
	"Send a HTTP request"
	
	^ self sendRequest: url method: 'GET'! !

!SNETTwitterFetcher methodsFor: 'private' stamp: 'EBA 10/25/2014 21:31'!
sendRequest: url method: method
	"Send a HTTP request"
	
	| response |
	response := [WebClient new httpGet: url do: [:req |
		req addHeader: 'User-Agent' value: UserAgent.
		req addHeader: 'Host' value: 'api.twitter.com'.
		req addHeader: 'Authorization' value: tokenType, ' ', accessToken.
		req method: method]]
	"Ignore all certificate issues when using HTTPS/SSL"
	on: SqueakSSLCertificateError do: [:ex | ex resume].
	
	^response content! !

!SNETTwitterFetcher methodsFor: 'accessing' stamp: 'AB 10/31/2014 17:38'!
tweets: text
	"Get tweets from hashtag"
	
	^ self tweets: text maximum: 20! !

!SNETTwitterFetcher methodsFor: 'accessing' stamp: 'AB 11/2/2014 23:11'!
tweets: text maximum: max
	"Get tweets from text"
	
	| url |
	url := ApiUrl, '1.1/search/tweets.json?q=', text encodeForHTTP, '&count=', max.
	
	^ SNETTwitterTweetsData new: (self sendRequest: url) type: 'INDIRECT'! !

!SNETTwitterFetcher methodsFor: 'accessing' stamp: 'AB 11/2/2014 23:11'!
tweets: text since: date maximum: max
	"Get tweets since date in format yyyy-mm-dd from text"
	
	| url |
	url := ApiUrl, '1.1/search/tweets.json?q=', text encodeForHTTP, '&since=', date yyyymmdd, '&count=', max.
	
	^ SNETTwitterTweetsData new: (self sendRequest: url) type: 'INDIRECT'! !

!SNETTwitterFetcher methodsFor: 'accessing' stamp: 'AB 11/2/2014 23:52'!
tweets: text since: initDate until: endDate maximum: max
	"Get tweets  from text since initDate (in format yyyy-mm-dd) until endDate (in format yyyy-mm-dd)"
	
	| url |
	url := ApiUrl, '1.1/search/tweets.json?q=', text encodeForHTTP, '&since=', initDate yyyymmdd,  '&until=', endDate yyyymmdd, '&count=', max.
	
	^ SNETTwitterTweetsData new: (self sendRequest: url) type: 'INDIRECT'! !

!SNETTwitterFetcher methodsFor: 'accessing' stamp: 'AB 11/2/2014 23:51'!
tweets: text until: date
		"Get tweets  from text until date (in format yyyy-mm-dd)"
	
	^ self tweets: text until: date maximum: 20! !

!SNETTwitterFetcher methodsFor: 'accessing' stamp: 'AB 11/2/2014 23:40'!
tweets: text until: date maximum: max
		"Get  tweets  from text until date (in format yyyy-mm-dd), which max is the number maximum of tweets"
	
	| url |
	url := ApiUrl, '1.1/search/tweets.json?q=', text encodeForHTTP, '&until=', date yyyymmdd, '&count=', max.
	
	^ SNETTwitterTweetsData new: (self sendRequest: url) type: 'INDIRECT'! !

!SNETTwitterFetcher methodsFor: 'accessing' stamp: 'AB 11/2/2014 23:40'!
tweetsFrom: text user: user
	"Get tweets from text from user"
	
	^ self tweetsFrom: text user: user maximum: 20! !

!SNETTwitterFetcher methodsFor: 'accessing' stamp: 'AB 11/2/2014 23:40'!
tweetsFrom: text user: user maximum: max
	"Get tweets from text from user, which max is the number maximum of tweets"
	
	| url |
	url := ApiUrl, '1.1/search/tweets.json?q=from', (user, ' ', text) encodeForHTTP, '&count=', max.
	
	^ SNETTwitterTweetsData new: (self sendRequest: url) type: 'INDIRECT'! !

!SNETTwitterFetcher methodsFor: 'accessing' stamp: 'AB 11/2/2014 23:42'!
tweetsFrom: text user: user since: date
	"Get  tweets  from text from user sice date (in format yyyy-mm-dd)"
	
	^ self tweetsFrom: text user: user since: date maximum: 20! !

!SNETTwitterFetcher methodsFor: 'accessing' stamp: 'AB 11/2/2014 23:42'!
tweetsFrom: text user: user since: date maximum: max 
	"Get  tweets  from text from user sice date (in format yyyy-mm-dd), which max is the number maximum of tweets"
	
	| url |
	url := ApiUrl, '1.1/search/tweets.json?q=from', (user, ' ', text) encodeForHTTP, '&since=', date yyyymmdd, '&count=', max.
	
	^ SNETTwitterTweetsData new: (self sendRequest: url) type: 'INDIRECT'! !

!SNETTwitterFetcher methodsFor: 'accessing' stamp: 'AB 11/2/2014 23:50'!
tweetsFrom: text user: user since: initDate until: endDate
	"Get  tweets  from text from user sice initDate (in format yyyy-mm-dd) until endDate"


	^ self tweetsFrom: text user: user since: initDate until: endDate maximum: 20! !

!SNETTwitterFetcher methodsFor: 'accessing' stamp: 'AB 11/2/2014 23:45'!
tweetsFrom: text user: user since: initDate until: endDate maximum: max 
	"Get  tweets  from text from user since initDate (in format yyyy-mm-dd) until endDate, which max is the number maximum of tweets"
	| url |
	url := ApiUrl, '1.1/search/tweets.json?q=from', (user, ' ', text) encodeForHTTP, '&since=', initDate yyyymmdd, '&until=', endDate yyyymmdd, '&count=', max.
	
	^ SNETTwitterTweetsData new: (self sendRequest: url) type: 'INDIRECT'! !

!SNETTwitterFetcher methodsFor: 'accessing' stamp: 'AB 11/2/2014 23:48'!
tweetsFrom: text user: user until: date
	"Get  tweets  from text from user until date (in format yyyy-mm-dd)"
	
	^ self tweetsFrom: text user: user until: date maximum: 20! !

!SNETTwitterFetcher methodsFor: 'accessing' stamp: 'AB 11/2/2014 23:48'!
tweetsFrom: text user: user until: date maximum: max 
	"Get  tweets  from text from user until endDate (in format yyyy-mm-dd), which max is the number maximum of tweets"
	
	| url |
	url := ApiUrl, '1.1/search/tweets.json?q=from', (user, ' ', text) encodeForHTTP, '&until=', date yyyymmdd, '&count=', max.
	
	^ SNETTwitterTweetsData new: (self sendRequest: url) type: 'INDIRECT'! !

Object subclass: #SNETTwitterTweet
	instanceVariableNames: 'id message retweets favorited'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'GODSocialNetIO'!

!SNETTwitterTweet class methodsFor: 'instance creation' stamp: 'EBA 10/26/2014 03:55'!
new: json
	| newInstance |
	newInstance := self new.
	
	newInstance setId: (json at: 'id' ifPresent: [:value | value]).
	newInstance setMessage: (json at: 'text' ifPresent: [:value | value]).
	newInstance setRetweets: (json at: 'retweet_count' ifPresent: [:value | value]) asInteger.
	newInstance setFavorited: (json at: 'favorite_count' ifPresent: [:value | value]) asInteger.
	
	^ newInstance! !

!SNETTwitterTweet methodsFor: 'accessing' stamp: 'EBA 10/26/2014 03:51'!
getFavorited
	"Get number of favorite from tweet"

	^ favorited! !

!SNETTwitterTweet methodsFor: 'accessing' stamp: 'EBA 10/26/2014 03:50'!
getId
	"Get id from tweet"

	^ id! !

!SNETTwitterTweet methodsFor: 'accessing' stamp: 'EBA 10/26/2014 03:51'!
getMessage
	"Get message from tweet"

	^ message! !

!SNETTwitterTweet methodsFor: 'accessing' stamp: 'EBA 10/26/2014 03:50'!
getRetweets
	"Get number of retweets from tweet"

	^ retweets! !

!SNETTwitterTweet methodsFor: 'private' stamp: 'EBA 10/26/2014 03:53'!
setFavorited: number
	"Set number of favorite from tweet"
	
	favorited := number! !

!SNETTwitterTweet methodsFor: 'private' stamp: 'EBA 10/26/2014 03:57'!
setId: idNumber
	"Set id from tweet"
	
	id := idNumber! !

!SNETTwitterTweet methodsFor: 'private' stamp: 'EBA 10/26/2014 03:45'!
setMessage: text
	"Set message from post"
	
	message := text! !

!SNETTwitterTweet methodsFor: 'private' stamp: 'EBA 10/26/2014 03:52'!
setRetweets: number
	"Set number of retweets from tweet"
	
	retweets := number! !
GODSocialNetIOServiceProvider initialize!
